PO_NAME = alterator-$(NAME)
POT_NAME = po/$(PO_NAME).pot
PO_KEYWORD=_

SCM_TRANSLATE = $(shell find ui -name '*.scm') $(wildcard backend2/*)
SH_TRANSLATE = $(shell [ -d backend3 ] && for i in backend3/*; do file $$i|fgrep -qs 'shell script text' && echo $$i;done)
JS_TRANSLATE = $(shell find html -name '*.js')

PO_FILES=$(wildcard po/*.po)
PO_LANGUAGES=$(PO_FILES:po/%.po=%)

LOCALEDIR=$(datadir)/locale

INSTALL=install
XGETTEXT=xgettext
MSGFMT=msgfmt
MSGMERGE=msgmerge

install-po:
	for i in $(PO_LANGUAGES); do \
	$(INSTALL) -d $(LOCALEDIR)/$$i/LC_MESSAGES; \
	$(MSGFMT) -o $(LOCALEDIR)/$$i/LC_MESSAGES/$(PO_NAME).mo po/$$i.po ;\
	done

scm-update-po:
	$(XGETTEXT)  --join-existing --add-comments -o$(POT_NAME) -L Lisp --keyword=$(PO_KEYWORD) $(SCM_TRANSLATE)

sh-update-po:
	$(XGETTEXT) --join-existing --add-comments -o$(POT_NAME) -L Shell --keyword=$(PO_KEYWORD) $(SH_TRANSLATE)

js-update-po:
	$(XGETTEXT) --join-existing --add-comments -o$(POT_NAME) -L C --keyword=$(PO_KEYWORD) $(JS_TRANSLATE)

update-po:
	$(INSTALL) -d po
	$(RM) $(POT_NAME)
	touch $(POT_NAME)
	[ -n "$(SCM_TRANSLATE)" ] && make scm-update-po || :
	[ -n "$(SH_TRANSLATE)" ] && make sh-update-po || :
	[ -n "$(JS_TRANSLATE)" ] && make js-update-po || :
	for i in $(PO_LANGUAGES);do \
	$(MSGMERGE) -U po/$$i.po $(POT_NAME); \
	done

build-po:
	$(INSTALL) -d po
	for i in $(PO_LANGUAGES); do \
	$(INSTALL) -d $(LOCALEDIR)/$$i/LC_MESSAGES; \
	$(MSGFMT) -o po/$$i.mo po/$$i.po ;\
	done

clean-po:
	$(RM) po/*.mo
	$(RM) po/*.po~
